// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from rc_common_msgs:msg/CameraParam.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "rc_common_msgs/msg/detail/camera_param__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace rc_common_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void CameraParam_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) rc_common_msgs::msg::CameraParam(_init);
}

void CameraParam_fini_function(void * message_memory)
{
  auto typed_message = static_cast<rc_common_msgs::msg::CameraParam *>(message_memory);
  typed_message->~CameraParam();
}

size_t size_function__CameraParam__line_source(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<rc_common_msgs::msg::KeyValue> *>(untyped_member);
  return member->size();
}

const void * get_const_function__CameraParam__line_source(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<rc_common_msgs::msg::KeyValue> *>(untyped_member);
  return &member[index];
}

void * get_function__CameraParam__line_source(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<rc_common_msgs::msg::KeyValue> *>(untyped_member);
  return &member[index];
}

void resize_function__CameraParam__line_source(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<rc_common_msgs::msg::KeyValue> *>(untyped_member);
  member->resize(size);
}

size_t size_function__CameraParam__extra_data(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<rc_common_msgs::msg::KeyValue> *>(untyped_member);
  return member->size();
}

const void * get_const_function__CameraParam__extra_data(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<rc_common_msgs::msg::KeyValue> *>(untyped_member);
  return &member[index];
}

void * get_function__CameraParam__extra_data(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<rc_common_msgs::msg::KeyValue> *>(untyped_member);
  return &member[index];
}

void resize_function__CameraParam__extra_data(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<rc_common_msgs::msg::KeyValue> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember CameraParam_message_member_array[7] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_common_msgs::msg::CameraParam, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "is_color_camera",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_BOOLEAN,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_common_msgs::msg::CameraParam, is_color_camera),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "exposure_time",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_common_msgs::msg::CameraParam, exposure_time),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "gain",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_common_msgs::msg::CameraParam, gain),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "line_status_all",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT32,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_common_msgs::msg::CameraParam, line_status_all),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "line_source",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_common_msgs::msg::KeyValue>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_common_msgs::msg::CameraParam, line_source),  // bytes offset in struct
    nullptr,  // default value
    size_function__CameraParam__line_source,  // size() function pointer
    get_const_function__CameraParam__line_source,  // get_const(index) function pointer
    get_function__CameraParam__line_source,  // get(index) function pointer
    resize_function__CameraParam__line_source  // resize(index) function pointer
  },
  {
    "extra_data",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<rc_common_msgs::msg::KeyValue>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(rc_common_msgs::msg::CameraParam, extra_data),  // bytes offset in struct
    nullptr,  // default value
    size_function__CameraParam__extra_data,  // size() function pointer
    get_const_function__CameraParam__extra_data,  // get_const(index) function pointer
    get_function__CameraParam__extra_data,  // get(index) function pointer
    resize_function__CameraParam__extra_data  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers CameraParam_message_members = {
  "rc_common_msgs::msg",  // message namespace
  "CameraParam",  // message name
  7,  // number of fields
  sizeof(rc_common_msgs::msg::CameraParam),
  CameraParam_message_member_array,  // message members
  CameraParam_init_function,  // function to initialize message memory (memory has to be allocated)
  CameraParam_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t CameraParam_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &CameraParam_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace rc_common_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<rc_common_msgs::msg::CameraParam>()
{
  return &::rc_common_msgs::msg::rosidl_typesupport_introspection_cpp::CameraParam_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, rc_common_msgs, msg, CameraParam)() {
  return &::rc_common_msgs::msg::rosidl_typesupport_introspection_cpp::CameraParam_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
